//version 1.1.7

package main;

import de.janitza.pasw.database.DeviceInformation
import de.janitza.pasw.database.IDBDeviceManager
import de.janitza.pasw.database.IDatabase
import de.janitza.pasw.database.IDatabaseManager
import de.janitza.pasw.database.IPluginConfiguration
import de.janitza.pasw.database.IValueDescCache
import de.janitza.pasw.database.ValueDescription
import de.janitza.pasw.database.values.IValueList


import de.janitza.pasw.value.core.api.tag.ITag;
import de.janitza.pasw.value.core.fluent.builder.TagBuilder;
import de.janitza.pasw.value.core.fluent.relation.RelationService;
import de.janitza.pasw.value.core.historical.api.provider.IHistoricalMeasuresProvider;

import de.janitza.pasw.energy.api.IProjectList
import de.janitza.pasw.energy.common.ServerLkp
import de.janitza.pasw.value.core.api.IValue
import de.janitza.pasw.value.core.legacy.api.Types
import de.janitza.pasw.value.core.legacy.api.ValueType
import de.janitza.pasw.value.core.legacy.api.Values
import de.janitza.pasw.device.core.api.IDevice;

import jdk.internal.org.objectweb.asm.tree.analysis.Value
import utils.MyUtils
import java.nio.charset.StandardCharsets
import java.nio.file.attribute.BasicFileAttributes;
import java.nio.file.attribute.FileTime;
import java.util.ArrayList;
import javax.ws.rs.GET;
import de.janitza.pasw.device.core.api.IDeviceValueService;
import de.janitza.pasw.device.core.api.IUserValue;
import static de.janitza.pasw.server.wars.entities.DeviceEnt.getConnectionStringWithoutPassword;
import javax.ws.rs.Path;
import javax.ws.rs.Produces;
import javax.ws.rs.core.MediaType;
import javax.ws.rs.PathParam;
import javax.ws.rs.QueryParam;
import de.janitza.pasw.project.server.ServerNameUtil;

import javax.xml.bind.annotation.*
import de.janitza.pasw.database.IValueFetcher
import java.nio.file.Files
import java.io.File;
import java.io.*;
import java.io.FileInputStream;
import java.io.FileNotFoundException;
import java.io.FileOutputStream;
import java.io.IOException;
import java.io.ObjectInputStream;
import java.io.ObjectOutputStream;
import java.io.Serializable;
import java.nio.file.attribute.BasicFileAttributes
import java.nio.file.attribute.FileTime
import java.text.SimpleDateFormat;
import org.openide.modules.Places;
import org.codehaus.groovy.runtime.EncodingGroovyMethods
import java.util.logging.Logger;
import java.util.logging.Level;
import de.janitza.pasw.device.core.service.api.IOnlineDataServiceManager;
import de.janitza.pasw.device.core.service.api.services.IOnlineDataService;

/**
 * Example Groovy JAX-RS resource.
 */

@XmlRootElement
@XmlAccessorType(XmlAccessType.FIELD)

@Path("collector")
class GroovyResource {
    def getMainProject(){
        def mainProj =  ServerNameUtil.getMainProjectFromPreferences().get();
        Logger.getLogger("csvadapter--web main.groovy").log(Level.FINE,"looking for main project "+mainProj);
                def p = ServerLkp.lookup(IProjectList).forName(mainProj).get();
                Logger.getLogger("csvadapter--web main.groovy").log(Level.FINE,"project "+(p==null?"not":"successfully")+" loaded");
                return p;
    }

    
    public static String unHex(String arg) {
        String str = "";
        for(int i=0;i<arg.length();i+=2)
        {
            String s = arg.substring(i, (i + 2));
            int decimal = Integer.parseInt(s, 16);
            str = str + (char) decimal;
        }
        return str;
    }

    
    public static boolean match(String text, String pattern)
    {
        return text.matches(createRegexFromGlob(pattern));
    }
    
    @Produces(MediaType.APPLICATION_JSON)
    @Path("test")
    @GET
    public String tt() {
            return "{\"test\":\"erfolgreich\"}";
    }
    


    
DeviceInformation findDevice(int devid) throws FileNotFoundException{
   def p = getMainProject();
     IDBDeviceManager devMan = p.getLookup().lookup(
                IDBDeviceManager.class
        );
        List<DeviceInformation> devices = devMan.getDevices();
        DeviceInformation retdev=null;
        devices.each{d->
          if(d.deviceId==devid)
            retdev=d;
        }
        if(retdev==null)
        throw new FileNotFoundException("device "+devid+" of "+devices.size()+" devices not found!");
      else{
        return retdev;
      }
}


 @Produces(MediaType.APPLICATION_JSON)
    @Path("status")
    @GET
    public String collector() {
           String ret;
            def p = getMainProject();
            IDatabaseManager dbMgr = p.getLookup().lookup(IDatabaseManager.class);
            IDatabase db = dbMgr.getLookup().lookup(IDatabase.class);
            IPluginConfiguration pluginConfiguration = db.getPluginConfiguration(
                    "collector.rest");
            ret = pluginConfiguration.getConfiguration("REST");
            return ret
        
    }



@Produces(MediaType.APPLICATION_JSON)
    @Path("version")
    @GET
    public String getVersion() {
           String ret;
            def p = getMainProject();
            IDatabaseManager dbMgr = p.getLookup().lookup(IDatabaseManager.class);
            IDatabase db = dbMgr.getLookup().lookup(IDatabase.class);
            IPluginConfiguration pluginConfiguration = db.getPluginConfiguration(
                    "collector.rest");
            ret = pluginConfiguration.getConfiguration("ReceiverVersion");
            return ret
        
    }

}
Logger.getLogger("csvadapter--web main.groovy").log(Level.INFO,"registering Rest");
registerRest(GroovyResource)
Logger.getLogger("csvadapter--web main.groovy").log(Level.INFO,"registered Rest");
//registerRunnable({it -> Export.runscripts();})
